//-----------------------------------------------------------------------------
/** @file example.cpp
    Example program using the pathfinding library.

    $Id: example.cpp,v 1.24 2002/12/09 22:10:19 emarkus Exp $
    $Source: /usr/cvsroot/project_pathfind/example.cpp,v $
*/
//-----------------------------------------------------------------------------

#include <memory>
#include "pathfind.h"
#include "abswizard.h"
#include "smoothwizard.h"
#include "experiment.h"

using namespace std;
using namespace PathFind;

//-----------------------------------------------------------------------------

int main(int argc, char **argv)
{
    if (argc != 8) {
      cerr << "Usage: " << argv[0] << " <n> <b> <l> <ll> <sm> <file> <paths>\n";
      exit(argc);
    }

    for(int i = 0; i < argc; i++)
        cerr << argv[i] << " ";
    cerr << "\n";
    int argi = 1;
    int nrRuns = atoi(argv[argi++]);
    int clSize = atoi(argv[argi++]);
    int maxLevel = atoi(argv[argi++]);
    int llSearch = atoi(argv[argi++]);
    bool doSmoothing = 1 == atoi(argv[argi++]);

    string mapfile = argv[argi++];
    string pathfile = argv[argi++];
    try {
	//srand(time(0));
	Experiment experiment(nrRuns, 10000000L, 0, 0,
			      0, (bool)llSearch, doSmoothing, true, true,
			      clSize, maxLevel, AbsWizard::END_ENTRANCE,
			      A_STAR, Tiling::OCTILE);
	experiment.setupExperiment();
	experiment.runExperiment(mapfile, pathfile);
      }
    catch (const exception& e) {
	cerr << "Error: " << e.what() << '\n';
	return -1;
    }
    return 0;
}

//-----------------------------------------------------------------------------
